import 'reflect-metadata';
import { inject, injectable } from 'inversify';
import { APIGatewayProxyEvent, APIGatewayProxyResult } from 'aws-lambda';

import * as Constants from '../constants.js';
import TokenService from '../services/token.service.js';
import { IAuthBodyException } from '../common/interfaces/authorization.inteface.js';
import CreateTokenRequest from '../requests/token/create-token.request.js';
import { ITokenRequestCreateOne, ITokenRequestFindOneByAutoGeneretedToken } from '../common/interfaces/requests/token.request.js';
import { isExpiredToken, validateTokenCreateOne, validateTokenFindOneByAutoGeneratedToken } from '../validation/tokens.validation.js';
import { IResponseTokenCreateOne, IResponseTokenFindOneByAutoGeneratedToken } from '../common/interfaces/responses/token-response.interface.js';
import { validateApiKey } from '../middlewares/utils/authorization.utils.js';

@injectable()
export default class TokenController {
  constructor(@inject(TokenService.name) private readonly tokenService: TokenService) {}

  async createOne(event: APIGatewayProxyEvent) {
    try {
      const { headers } = event;

      if (!headers) {
        const body: IAuthBodyException = {
          message: Constants.NO_HEADERS,
          timestamp: new Date(),
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        const bodyString = JSON.stringify(body);
  
        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        return errorResponse;
      }
  
      const authorization = headers?.authorization || headers?.Authorization;
  
      if (!authorization) {
        const body: IAuthBodyException = {
          timestamp: new Date(),
          message: Constants.NOT_API_KEY,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        const bodyString = JSON.stringify(body);
  
        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        return errorResponse;
      }
  
      const [type, apiKey] = authorization.split(' ');
  
      const isTypeCorrect = type == Constants.AUTHORIZATION_TYPE;
      const isApiKeyLengthCorrect = apiKey?.length == Constants.AUTHORIZATION_LENGTH;
      const isApiKeyCorrect = validateApiKey(apiKey);
  
      const isValidAuth = isTypeCorrect || isApiKeyLengthCorrect || isApiKeyCorrect;
  
      if (!isValidAuth) {
        const body: IAuthBodyException = {
          timestamp: new Date(),
          message: Constants.NOT_VALID_API_KEY,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        const bodyString = JSON.stringify(body);
  
        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        return errorResponse;
      }

      if (!event.body) {
        const errorBody: IAuthBodyException = {
          message: 'No body',
          timestamp: new Date(),
          statusCode: Constants.HTTP_STATUS_404,
        };

        const errorBodyString = JSON.stringify(errorBody);

        const errorResponse: APIGatewayProxyResult = {
          body: errorBodyString,
          statusCode: Constants.HTTP_STATUS_400,
        };

        return errorResponse;
      }

      const body: ITokenRequestCreateOne = JSON.parse(event.body);

      const tokenValidated = validateTokenCreateOne(body);

      const isValidToken = tokenValidated.isValid;

      if (!isValidToken) {
        const errorResponse: APIGatewayProxyResult = {
          body: tokenValidated.message,
          statusCode: Constants.HTTP_STATUS_400,
        };

        return errorResponse;
      }

      const tokenDto: CreateTokenRequest = new CreateTokenRequest(body);
      const tokenCreated = await this.tokenService.createOne(tokenDto);
      const tokenAutoGenerated = tokenCreated.auto_generated_token as string;

      const responseTokenCreateOne: IResponseTokenCreateOne = { token: tokenAutoGenerated }

      const result: APIGatewayProxyResult = {
        statusCode: Constants.HTTP_STATUS_200,
        body: JSON.stringify(responseTokenCreateOne),
      };
      return result;
    } catch (error) {
      const errorResponse: APIGatewayProxyResult = {
        body: JSON.stringify({ error }),
        statusCode: Constants.HTTP_STATUS_500,
      };

      return errorResponse;
    }
  }

  async findOneByAutoGeneratedToken(event: APIGatewayProxyEvent) {
    try {
      const { headers } = event;

      if (!headers) {
        const body: IAuthBodyException = {
          message: Constants.NO_HEADERS,
          timestamp: new Date(),
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        const bodyString = JSON.stringify(body);
  
        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        return errorResponse;
      }
  
      const authorization = headers?.authorization || headers?.Authorization;
  
      if (!authorization) {
        const body: IAuthBodyException = {
          timestamp: new Date(),
          message: Constants.NOT_API_KEY,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        const bodyString = JSON.stringify(body);
  
        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        return errorResponse;
      }
  
      const [type, apiKey] = authorization.split(' ');
  
      const isTypeCorrect = type == Constants.AUTHORIZATION_TYPE;
      const isApiKeyLengthCorrect = apiKey?.length == Constants.AUTHORIZATION_LENGTH;
      const isApiKeyCorrect = validateApiKey(apiKey);
  
      const isValidAuth = isTypeCorrect || isApiKeyLengthCorrect || isApiKeyCorrect;
  
      if (!isValidAuth) {
        const body: IAuthBodyException = {
          timestamp: new Date(),
          message: Constants.NOT_VALID_API_KEY,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        const bodyString = JSON.stringify(body);
  
        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_401,
        };
  
        return errorResponse;
      }

      if(!event.queryStringParameters) {
        const errorBody: IAuthBodyException = {
          message: 'No query string parameters',
          timestamp: new Date(),
          statusCode: Constants.HTTP_STATUS_400,
        };

        const errorBodyString = JSON.stringify(errorBody);

        const errorResponse: APIGatewayProxyResult = {
          body: errorBodyString,
          statusCode: Constants.HTTP_STATUS_400,
        };

        return errorResponse;
      }

      const { queryStringParameters } = event

      const tokenQuery = queryStringParameters.token as string

      const query: ITokenRequestFindOneByAutoGeneretedToken = {
        token: tokenQuery
      }
      
      const tokenValidated = validateTokenFindOneByAutoGeneratedToken(query)
      const isValidToken = tokenValidated.isValid

      if(!isValidToken) {
        const errorResponse: APIGatewayProxyResult = {
          body: tokenValidated.message,
          statusCode: Constants.HTTP_STATUS_400,
        };

        return errorResponse;
      }

      const { token } = query
      
      const tokenFound = await this.tokenService.findOneByAutoGeneratedToken(token)

      if(!tokenFound) {
        const bodyString = JSON.stringify({ message: 'No token found' })
        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_404,
        };

        return errorResponse;
      }

      const isExpiredTokenFound = isExpiredToken(tokenFound)

      if(isExpiredTokenFound) {
        const tokenId = tokenFound._id as string
        await this.tokenService.setTokenExpired(tokenId)

        const bodyString = JSON.stringify({ message: 'The token has expired. Sorry' })

        const errorResponse: APIGatewayProxyResult = {
          body: bodyString,
          statusCode: Constants.HTTP_STATUS_404,
        };

        return errorResponse;
      } 
      
      const responseTokenFindOneByAutoGeneratedToken: IResponseTokenFindOneByAutoGeneratedToken = {
        ...tokenFound
      }

      const result: APIGatewayProxyResult = {
        statusCode: Constants.HTTP_STATUS_200,
        body: JSON.stringify(responseTokenFindOneByAutoGeneratedToken) 
      }

      return result
    } 
    catch (error) {
      const errorResponse: APIGatewayProxyResult = {
        body: JSON.stringify({ error }),
        statusCode: Constants.HTTP_STATUS_500,
      };

      return errorResponse;
    }
  }
}
